/*
 * Initial main.c file generated by Glade. Edit as required. Glade will not
 * overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gnome.h>

#include "defs.h"		/* gems includes */
#include "message.h"
#include "face.h"
#include "../../../include/db.h"

#include "interface.h"		/* glade includes for this face */
#include "support.h"

GtkWidget *gems;		/* global. ick. */

#include "extra.h"

int default_mboxlistbehavior = DB_UNREAD;

void
oops (char *a, char *b)
{
    printf ("%s: %s\n", a, b);
}

gint
update_mboxlist (gpointer nothing)
{
    mboxs **mboxlist;
    GtkCTree *tree;
    int x = 0;
    mboxlist = (mboxs **) db_read_mboxlist ();
    tree = GTK_CTREE (lookup_widget (gems, "ctree2"));
    gtk_clist_freeze (&GTK_CTREE (tree)->clist);
    x = 0;
    while (mboxlist[x] != NULL)
    {
	gtk_clist_set_foreground (&(tree->clist), x,
				  (mboxlist[x]->hasunread >
				   0) ? color_magenta : color_black);
	x++;
    }
    gtk_clist_thaw (&GTK_CTREE (tree)->clist);
    return 1;
}

void
set_mboxlist ()
{
    int x;
    mboxs **mboxlist;
    GtkCTree *tree;
    char *read, *unread, *marked, *all;

    mboxlist = (mboxs **) db_read_mboxlist ();
    tree = GTK_CTREE (lookup_widget (gems, "ctree2"));
    all = strdup ("all");
    read = strdup ("read");
    unread = strdup ("unread");
    marked = strdup ("marked");

    gtk_clist_freeze (&GTK_CTREE (tree)->clist);
    gtk_clist_clear (&GTK_CTREE (tree)->clist);

    x = 0;
    while (mboxlist[x] != NULL)
    {
	GtkCTreeNode *node, *n;
	char *text;

	text = mboxlist[x]->name;
	node =
	    gtk_ctree_insert_node (tree, NULL, NULL, &text, 5, NULL,
				   NULL, NULL, NULL, FALSE, FALSE);
	gtk_ctree_node_set_row_data (tree, node,
				     new_mboxview (mboxlist[x],
						   default_mboxlistbehavior));
	n = gtk_ctree_insert_node (tree, node, NULL, &all, 5, NULL, NULL,
				   NULL, NULL, TRUE, TRUE);
	gtk_ctree_node_set_row_data (tree, n,
				     new_mboxview (mboxlist[x], DB_ALL));
	n = gtk_ctree_insert_node (tree, node, NULL, &unread, 5, NULL, NULL,
				   NULL, NULL, TRUE, TRUE);
	gtk_ctree_node_set_row_data (tree, n,
				     new_mboxview (mboxlist[x], DB_UNREAD));
	n = gtk_ctree_insert_node (tree, node, NULL, &read, 5, NULL, NULL,
				   NULL, NULL, TRUE, TRUE);
	gtk_ctree_node_set_row_data (tree, n,
				     new_mboxview (mboxlist[x], DB_READ));
	n = gtk_ctree_insert_node (tree, node, NULL, &marked, 5, NULL, NULL,
				   NULL, NULL, TRUE, TRUE);
	gtk_ctree_node_set_row_data (tree, n,
				     new_mboxview (mboxlist[x], DB_MARKED));

	x++;
    }

    /*
     * gtk_ctree_select(GTK_CTREE (tree), select_node);
     */
    gtk_clist_thaw (&GTK_CTREE (tree)->clist);
    free (mboxlist);
    update_mboxlist (NULL);
    return;
}


int
face_uses_X ()
{
    return TRUE;
}

int
face_run (int argc, char *argv[])
{
    char *x;
    int a = 0, b = 0;
    GtkCList *c;

#ifdef ENABLE_NLS
    bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
    textdomain (PACKAGE);
#endif
    gnome_init ("gems", VERSION, argc, argv);
    gems = create_gems ();
    gtk_widget_realize (gems);

    color_magenta = (GdkColor *) malloc (sizeof (GdkColor));
    color_black = (GdkColor *) malloc (sizeof (GdkColor));

    color_magenta->red = (65535);
    color_magenta->green = (0);
    color_magenta->blue = (0);
    color_black->red = (0);
    color_black->green = (0);
    color_black->blue = (0);
    if (!gdk_color_alloc (gdk_colormap_get_system (), color_magenta))
	g_error (_("Color allocation failed\n"));
    if (!gdk_color_alloc (gdk_colormap_get_system (), color_black))
	g_error (_("Color allocation failed\n"));


    set_mboxlist ();
    if ((x = (char *) db_pref_get ("GNOME_o_hpaned_pos")) != NULL)
	gtk_paned_set_position (GTK_PANED (lookup_widget (gems, "hpaned1")),
				atoi (x));

    if ((x = (char *) db_pref_get ("GNOME_o_vpaned_pos")) != NULL)
	gtk_paned_set_position (GTK_PANED (lookup_widget (gems, "vpaned1")),
				atoi (x));
    if ((x = (char *) db_pref_get ("GNOME_o_gems_width")) != NULL)
	a = atoi (x);
    if ((x = (char *) db_pref_get ("GNOME_o_gems_height")) != NULL)
	b = atoi (x);
    if (a != 0 || b != 0)
	gtk_window_set_default_size (GTK_WINDOW (gems), a, b);
    if ((x = (char *) db_pref_get ("GNOME_o_gems_xpos")) != NULL)
	a = atoi (x);
    if ((x = (char *) db_pref_get ("GNOME_o_gems_ypos")) != NULL)
	b = atoi (x);
    if (a != 0 || b != 0)
	gtk_window_reposition (GTK_WINDOW (gems), a, b);
    if ((x = (char *) db_pref_get ("mboxdefaultaction")) != NULL)
	default_mboxlistbehavior = atoi (x);
    c = GTK_CLIST (&((GTK_CTREE (lookup_widget (gems, "ctree1")))->clist));
    if ((x = (char *) db_pref_get ("GNOME_o_maillist_col1")) != NULL)
	c->column[0].width = atoi (x);
    if ((x = (char *) db_pref_get ("GNOME_o_maillist_col2")) != NULL)
	c->column[1].width = atoi (x);

    gtk_widget_show (gems);
    gtk_timeout_add (600000, update_mboxlist, NULL);
    gtk_main ();

    return 0;
}
